import math

# This is a generic Discrete Random Variable object.
class DiscreteRandomVariable:
    
    # Input: This constructor accepts as input, a ProbabilityMassFunction, which is a dictionary, such that keys correspond to values 
    #        in the alphabet, and values are the associated probability value.
    # Process: This constructor sets the Alphabet and Probability Mass Function of this variable up, as global variables.
    def __init__(self, ProbabilityMassFunction):
        self.Alphabet = list(ProbabilityMassFunction.keys())
        self.ProbabilityMassFunction = ProbabilityMassFunction
        
    # Process: This method computes the Entropy of the random variable.
    # Output: The Entropy of the random variable      
    def compute_Entropy(self):
        Sum = 0
        for Value in self.Alphabet:
            if self.ProbabilityMassFunction[Value] != 0:
                Sum = Sum + self.ProbabilityMassFunction[Value] * math.log(self.ProbabilityMassFunction[Value],2)
        return -Sum
    
    # Prints out the probability mass function
    def print_Probability_Mass_Function(self):
        for Value in list(self.ProbabilityMassFunction.keys()):
            print (str(Value) + "\t" + str(self.ProbabilityMassFunction[Value]))